var React = require('react');
var ReactDOM = require('react-dom');

var FileInput = require('./FileInput.jsx');

var ConfigFieldFile = React.createClass({
  handleOnChange: function(value, data) {
    ReactDOM.findDOMNode(this.refs.file).value = '';
    if (this.props.handleChange) {
      if (this.props.multiple) {
        this.props.handleChange(this.props.name, value, data);
      } else {
        this.props.handleChange(
          this.props.name,
          value ? value[0] : '',
          data ? data[0] : ''
        );
      }
    }
  },

  getFilenamesText: function() {
    if (this.props.multiple) {
      if (this.props.multi_value && this.props.multi_value.length) {
        return this.props.multi_value.join(', ');
      }
    } else if (this.props.value) {
      return this.props.value;
    }
    return this.props.default;
  },

  render: function() {
    return (
      <div className="field field-type-file">
        <label>{this.props.title}</label>
        <div className="input input-type-file clearfix">
          <div>
            <span>
              <FileInput
                ref="file"
                name={this.props.name}
                readOnly={this.props.readonly}
                multiple={this.props.multiple}
                onChange={this.handleOnChange} />
            </span>
            <small>{this.getFilenamesText()}</small>
          </div>
        </div>
      </div>
    );
  }
});

module.exports = ConfigFieldFile;
