var _ = require('lodash');
var React = require('react');

var ConfigGroup = require('./ConfigGroup.jsx');
var ItemStore = require('../services/ItemStore');

var ConfigGroups = React.createClass({
  handleGroupChange: function(groupName, itemName, value, data) {
    if (this.props.handleChange) {
      this.props.handleChange(groupName, itemName, value, data);
    }
  },

  render: function() {
    var groups = _.map(ItemStore.getEnabledGroups(), function(group) {
      return (
        <ConfigGroup
          key={group.name}
          group={group}
          handleChange={this.handleGroupChange.bind(this, group.name)}
          onTestProc={this.props.onTestProc} />
      );
    }.bind(this));

    return (
      <div className="replicated-config">
        {groups}
      </div>
    );
  }
});

module.exports = ConfigGroups;
